﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Silverlight.Chart;

namespace SilverlightChartTest
{
    public partial class MainPage : UserControl
    {
        bool bLoaded = false;
        DateTime dStart = DateTime.MinValue, dAfterCall = DateTime.MinValue, dEnd = DateTime.MinValue;
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            List<DateTime> dts = new List<DateTime>();
            List<double> v1s = new List<double>();
            List<double> v2s = new List<double>();

            DateTime d = new DateTime(2000, 1, 1);
            Random rnd = new Random();
            for (int i = 0; i < 1000; i++) // You can test it with i < 10 and i < 100 and i < 200 and soem other values to check the change in behaviour
            {
                dts.Add(d.AddDays(i));
                v1s.Add(rnd.NextDouble() * i);
                v2s.Add(rnd.NextDouble() * i);
            }
            this.dStart = DateTime.Now;
            this.PopulateValuationMulipleChart(dts, v1s, v2s);
            this.dAfterCall = DateTime.Now;
        }

        private void PopulateValuationMulipleChart(List<DateTime> dts, List<double> v1s, List<double> v2s)        
        {
            this.bLoaded = false;
            this.cht.RefreshEnabled = false;

            Series seriesTargetValues = this.cht.Series[0];
            Series seriesValues = this.cht.Series[1];

            seriesTargetValues.DataPoints.Clear();
            seriesValues.DataPoints.Clear();

            bool bDataStarted = false;
            DataPoint dp;
            for (int i = 0; i < dts.Count; i++)
            {
                if (bDataStarted == false)
                {
                    if (double.IsNaN(v1s[i]))
                        continue;
                    else
                        bDataStarted = true;
                }
                dp = new DataPoint(v1s[i], dts[i].ToString("MM/dd/yyyy"));
                dp.ToolTip = v1s[i].ToString() + " on " + dts[i].ToString("MM/dd/yyyy"); 
                seriesTargetValues.DataPoints.Add(dp);

                dp = new DataPoint(v2s[i], dts[i].ToString("MM/dd/yyyy"));
                dp.ToolTip = v2s[i].ToString() + " on " + dts[i].ToString("MM/dd/yyyy"); 
                
                seriesValues.DataPoints.Add(dp);
            }

            //Axis xAxis = this.cht.Axes[0];
            //xAxis.Label.Angle = 90;            
            //xAxis.Unit = 10;
            //xAxis.AutoRange = true;

            //Axis yAxis = this.cht.Axes[1];
            //yAxis.Unit = 0;
            //yAxis.AutoRange = true;


            this.cht.RefreshEnabled = true;
            this.bLoaded = true;
        }

        private void LayoutRoot_LayoutUpdated(object sender, EventArgs e)
        {
            if (this.bLoaded == true)
            {
                this.dEnd = DateTime.Now;

                MessageBox.Show("Time For Call and Population:" + this.dAfterCall.Subtract(this.dStart).TotalMilliseconds.ToString() +
                                "\nTime For Complete Refresh:" + this.dEnd.Subtract(this.dStart).TotalMilliseconds.ToString());
                this.bLoaded = false;
            }
        }
    }
}
